﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace ICallisto
{
    /// <summary>Banned user object</summary>
    public interface IBan
    {
        /// <summary>Get the user's guid</summary>
        String Guid { get; }
        /// <summary>Get the user's external ip address</summary>
        IPAddress ExternalIP { get; }
        /// <summary>Get the user's local ip address</summary>
        IPAddress LocalIP { get; }
        /// <summary>Get/Set the user's name</summary>
        String Name { get; }
        /// <summary>Get the user's client version</summary>
        String Version { get; }
        /// <summary>Get the user's data port</summary>
        ushort Port { get; }
        /// <summary>Set to false to unban this user</summary>
        bool Banned { get; set; }
        /// <summary>Get the next user in this pool</summary>
        IBan NextUser { get; }
    }
}
