﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace ICallisto
{
    /// <summary>Link module helpers</summary>
    public interface ILinker
    {
        /// <summary>Get linked room's hashlink</summary>
        String Hashlink { get; }
        /// <summary>Get linked room's user count</summary>
        ushort UserCount { get; }
        /// <summary>Get linked room's name</summary>
        String Name { get; }
        /// <summary>Get linked room's ip address</summary>
        IPAddress ExternalIP { get; }
        /// <summary>Get linked room's port</summary>
        ushort Port { get; }
        /// <summary>Get current link mode</summary>
        LinkMode Mode { get; }
        /// <summary>Get link status of this server</summary>
        bool IsLinked { get; }
        /// <summary>Get linking functionality for this server</summary>
        bool AllowLinking { get; }
        /// <summary>Get linked admin functionality for this server</summary>
        bool AllowLinkedAdmin { get; }
        /// <summary>Begin link session with another chatroom</summary>
        void Connect(String hashlink);
        /// <summary>End link session with another chatroom</summary>
        void Disconnect();
    }
}
