﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace ICallisto
{
    /// <summary>Room settings helpers</summary>
    public interface IRoom
    {
        /// <summary>Get/Set room font</summary>
        IAresFont Font { get; set; }
        /// <summary>Get room name</summary>
        String Name { get; }
        /// <summary>Get/Set room topic</summary>
        String Topic { get; set; }
        /// <summary>Get room external ip</summary>
        IPAddress ExternalIP { get; }
        /// <summary>Get room local ip</summary>
        IPAddress LocalIP { get; }
        /// <summary>Get room port</summary>
        ushort Port { get; }
        /// <summary>Get room hashlink</summary>
        String Hashlink { get; }
        /// <summary>Get room start time (unix timestamp)</summary>
        uint StartTime { get; }
        /// <summary>Get service active status</summary>
        bool IsRunning { get; }
        /// <summary>Get room language</summary>
        Language Language { get; }
        /// <summary>Permanently set a new url</summary>
        void UpdateURL(String address, String text);
        /// <summary>Disabled url</summary>
        void UpdateURL();
        /// <summary>Get bot name</summary>
        String BotName { get; }
        /// <summary>Get/Set custom name enabled status</summary>
        bool CustomName { get; set; }
    }
}
