﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ICallisto
{
    /// <summary>Custom link protocol exception enumerator</summary>
    public enum LinkError : byte
    {
        /// <summary>You are trying to link to your own server</summary>
        LinkToSelf = 0,
        /// <summary>Target room has linking disabled</summary>
        LinkingDisabled = 3,
        /// <summary>Target room has an invalid link protocol</summary>
        OldProtocol = 4,
        /// <summary>Unknown</summary>
        NoInbound = 5,
        /// <summary>Target room is banned</summary>
        BannedUser = 9,
        /// <summary>Target room has invalid chatroom language</summary>
        WrongLanguage = 10,
        /// <summary>Target room is not on trusted server list</summary>
        NotOnAllowList = 88,
        /// <summary>Target room has link admin disabled</summary>
        LinkAdminDisabled = 89,
        /// <summary>Incorrectly formed hashlink</summary>
        InvalidHashlink = 90,
        /// <summary>Link connection is too laggy</summary>
        PingTimeout = 91,
        /// <summary>Connection to linked server was disconnected</summary>
        RemoteConnectionLost = 92,
        /// <summary>Protocol defied</summary>
        MaliciousPacket = 93
    }

    /// <summary>Link mode enumerator</summary>
    public enum LinkMode
    {
        /// <summary>Link mode</summary>
        Client = 0,
        /// <summary>Link mode</summary>
        Server = 1
    }
}
