﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace callisto
{
    class CallistoCustomDataManager
    {
        private List<CallistoCustomDataItem> items = new List<CallistoCustomDataItem>();

        public void DeleteData(String plugin)
        {
            this.items.RemoveAll(x => x.plugin == plugin);
        }

        public Dictionary<String, object> GetData
        {
            get
            {
                CallistoCustomDataItem i = this.items.Find(x => x.plugin == CallistoPluginManager.CurrentPlugin);

                if (i != null)
                    return i.dictionary;

                this.items.Add(new CallistoCustomDataItem(CallistoPluginManager.CurrentPlugin));
                return this.items[this.items.Count - 1].dictionary;
            }
        }
    }

    class CallistoCustomDataItem
    {
        public String plugin;
        public Dictionary<String, object> dictionary;

        public CallistoCustomDataItem(String plugin)
        {
            this.plugin = plugin;
            this.dictionary = new Dictionary<String, object>();
        }
    }
}
