﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using ICallisto;

namespace callisto
{
    class CallistoPluginLinker : ILinker
    {
        public LinkMode Mode
        {
            get { return CallistoServer.Linker.IsLinking ? CallistoServer.Linker.Mode : LinkMode.Server; }
        }

        public ushort Port
        {
            get { return CallistoServer.Linker.IsLinking ? CallistoServer.Linker.Port : (ushort)0; }
        }

        public IPAddress ExternalIP
        {
            get { return CallistoServer.Linker.IsLinking ? CallistoServer.Linker.ExternalIP : IPAddress.Any; }
        }

        public String Name
        {
            get { return CallistoServer.Linker.IsLinking ? CallistoServer.Linker.Name : String.Empty; }
        }

        public bool AllowLinkedAdmin
        {
            get { return Settings.AdminLinking; }
        }

        public bool AllowLinking
        {
            get { return Settings.RoomLinking; }
        }

        public bool IsLinked
        {
            get { return CallistoServer.Linker.IsLinking; }
        }

        public ushort UserCount
        {
            get { return CallistoServer.Linker.IsLinking ? ((ushort)CallistoServer.Linker.linked_users.Count) : (ushort)0; }
        }

        public String Hashlink
        {
            get { return CallistoServer.Linker.IsLinking ? CallistoServer.Linker.Hashlink : String.Empty; }
        }

        public void Disconnect()
        {
            if (CallistoServer.Linker.IsLinking)
                CallistoServer.Linker.PartAndDisconnect();
            else if (CallistoServer.Linker.IsActive)
                CallistoServer.Linker.Disconnect();
        }

        public void Connect(String hashlink)
        {
            CallistoServer.Linker.Connect(hashlink, Helpers.UnixTime);
        }
    }
}
