﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using ICallisto;

namespace callisto
{
    class CallistoPluginRoom : IRoom
    {
        public IAresFont Font
        {
            get { return Settings.font; }
            set
            {
                Settings.font = new AresFont(value.Size, value.Name);
                Settings.Save();

                if (Settings.ServerRunning)
                    UserPool.BroadcastToAll(ChatPacketHelpers.CustomFont(Settings.font));
            }
        }

        public bool CustomName
        {
            get { return Settings.CAN_CUSTOM_NAME; }
            set { Settings.CAN_CUSTOM_NAME = value; }
        }

        public Language Language
        {
            get { return (Language)Helpers.ComboBoxLanguageToAresLanguage(Settings.ServerLanguage); }
        }

        public bool IsRunning
        {
            get { return Settings.ServerRunning; }
        }

        public uint StartTime
        {
            get { return Settings.StartTime; }
        }

        public String Hashlink
        {
            get
            {
                ChannelObject chan = new ChannelObject();
                chan.external_ip = Settings.ServerIP;
                chan.local_ip = Settings.ServerIP;
                chan.name = Settings.ServerName;
                chan.port = (ushort)Settings.ServerPort;
                chan.topic = String.Empty;
                String str = HashlinkHelpers.EncodeHashlink(chan);
                return str;
            }
        }

        public ushort Port
        {
            get { return (ushort)Settings.ServerPort; }
        }

        public IPAddress LocalIP
        {
            get { return Settings.ServerIP; }
        }

        public IPAddress ExternalIP
        {
            get { return Settings.ServerIP; }
        }

        public String Topic
        {
            get { return Settings.ServerTopic; }
            set { Settings.ServerTopic = value; }
        }

        public String Name
        {
            get { return Settings.ServerName; }
        }

        public String BotName
        {
            get { return Settings.BotName; }
        }

        public void UpdateURL()
        {
            Settings.Url = new String[] { String.Empty, String.Empty };
        }

        public void UpdateURL(String address, String text)
        {
            Settings.Url = new String[] { address, text };
        }
    }
}
