﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ICallisto;

namespace callisto
{
    class CallistoPluginStats : IStats
    {
        internal static uint peak_user_count;
        internal static uint part_count;
        internal static uint join_count;
        internal static uint rejection_count;
        internal static uint flood_count;
        internal static uint invalid_login_attempts;
        internal static uint private_messages;
        internal static uint public_messages;
        internal static ulong data_sent;
        internal static ulong data_received;

        internal static void ResetStats()
        {
            peak_user_count = 0;
            part_count = 0;
            join_count = 0;
            rejection_count = 0;
            flood_count = 0;
            invalid_login_attempts = 0;
            private_messages = 0;
            public_messages = 0;
            data_sent = 0;
            data_received = 0;
        }

        public uint CurrentUserCount
        {
            get { return UserPool.UserCount; }
        }

        public uint PeakUserCount
        {
            get { return peak_user_count; }
        }

        public uint PartCount
        {
            get { return part_count; }
        }

        public uint JoinCount
        {
            get { return join_count; }
        }

        public uint RejectionCount
        {
            get { return rejection_count; }
        }

        public uint FloodCount
        {
            get { return flood_count; }
        }

        public uint InvalidLoginAttempts
        {
            get { return invalid_login_attempts; }
        }

        public uint PrivateMessages
        {
            get { return private_messages; }
        }

        public uint PublicMessages
        {
            get { return public_messages; }
        }

        public ulong DataSent
        {
            get { return data_sent; }
        }

        public ulong DataReceived
        {
            get { return data_received; }
        }
    }
}
