﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Net;
using ICallisto;

namespace callisto
{
    class Helpers
    {
        public static String StripColors(String text)
        {
            String input = text;

            if (Regex.IsMatch(input, @"\x03|\x05", RegexOptions.IgnoreCase))
                input = Regex.Replace(input, @"(\x03|\x05)[0-9]{2}", "");

            input = input.Replace("\x06", "");
            input = input.Replace("\x07", "");
            input = input.Replace("\x09", "");
            input = input.Replace("\x02", "");
            input = input.Replace("­", "");

            return input;
        }

        public static String FormatAresColorCodes(String text)
        {
            String result = text;
            result = result.Replace("\x00023", "\x0003");
            result = result.Replace("\x00025", "\x0005");
            result = result.Replace("\x00026", "\x0006");
            result = result.Replace("\x00027", "\x0007");
            result = result.Replace("\x00029", "\x0009");
            return result;
        }

        public static byte ComboBoxLanguageToAresLanguage(int index)
        {
            switch (index)
            {
                case 0: return 11;
                case 1: return 12;
                case 2: return 14;
                case 3: return 15;
                case 4: return 16;
                case 5: return 10;
                case 6: return 27;
                case 7: return 28;
                case 8: return 29;
                case 9: return 30;
                case 10: return 17;
                case 11: return 19;
                case 12: return 20;
                case 13: return 21;
                case 14: return 31;
                case 15: return 22;
                case 16: return 23;
                case 17: return 25;
                case 18: return 26;
                default: return 10;
            }
        }

        private static Random rnd;

        public static List<IPAddress> last_typer = new List<IPAddress>();

        public static uint UnixTime
        {
            get
            {
                TimeSpan ts = (DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0));
                return (uint)ts.TotalSeconds;
            }
        }

        public static long UnixTimeMS
        {
            get
            {
                TimeSpan ts = (DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0));
                return (long)ts.TotalMilliseconds;
            }
        }

        public static bool IsLocalHost(IPAddress ip)
        {
            byte[] buff = ip.GetAddressBytes();

            switch (buff[0])
            {
                case 192:
                    if (buff[1] == 168) return true;
                    break;

                case 127:
                    return true;

                case 10:
                    if (buff[1] == 0) return true;
                    break;

                default:
                    break;
            }

            if (ip.Equals(Settings.ServerIP)) return true;

            return false;
        }

        public static uint FirewallCookie
        {
            get
            {
                if (rnd == null)
                    rnd = new Random();

                return (uint)rnd.Next(0, 65535);
            }
        }

        public static AresPacket[] GetPacketsFromZip(byte[] data)
        {
            List<byte> data_in = new List<byte>(Zip.Decompress(data));
            List<AresPacket> packets = new List<AresPacket>();

            while (data_in.Count >= 3)
            {
                AresPacket packet = new AresPacket();
                packet.Size = BitConverter.ToUInt16(data_in.ToArray(), 0);
                packet.Msg = (ProtoMessage)data_in[2];

                if (data_in.Count >= (packet.Size + 3))
                {
                    data_in.RemoveRange(0, 3);
                    packet.Packet = data_in.GetRange(0, packet.Size).ToArray();
                    data_in.RemoveRange(0, packet.Size);
                    packets.Add(packet);
                }
                else { break; }
            }

            return packets.ToArray();
        }

        public static void FormatUsername(UserObject userobj)
        {
            if (userobj.name == Settings.BotName)
                userobj.name = String.Empty;

            userobj.name = Regex.Replace(userobj.name, "_", " ", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "￼", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "­", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "\"", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "/", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, @"\\", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "www.", "", RegexOptions.IgnoreCase);

            while (Encoding.UTF8.GetByteCount(userobj.name) > 20)
                userobj.name = userobj.name.Substring(0, userobj.name.Length - 1);

            if (userobj.name.Length < 2)
                userobj.name = "anon " + userobj.spawn_time;
        }

        public static void FormatUsername(WebUser userobj)
        {
            if (userobj.name == Settings.BotName)
                userobj.name = String.Empty;

            userobj.name = Regex.Replace(userobj.name, "_", " ", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "￼", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "­", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "\"", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "/", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, @"\\", "", RegexOptions.IgnoreCase);
            userobj.name = Regex.Replace(userobj.name, "www.", "", RegexOptions.IgnoreCase);
            userobj.name = userobj.name.Replace("\x0009", "").Replace("\r", "").Replace("\n", "");

            while (Encoding.UTF8.GetByteCount(userobj.name) > 20)
                userobj.name = userobj.name.Substring(0, userobj.name.Length - 1);

            if (userobj.name.Length < 2)
                userobj.name = "ib0t " + userobj.Time;
        }

        public static void FormatUsername(UserObject userobj, String proposed_name)
        {
            if (proposed_name == Settings.BotName)
                return;

            proposed_name = Regex.Replace(proposed_name, "_", " ", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "￼", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "­", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "\"", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "/", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, @"\\", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "www.", "", RegexOptions.IgnoreCase);

            if (proposed_name.Length < 2) // min name length is 2 bytes
                return;

            while (Encoding.UTF8.GetByteCount(proposed_name) > 20) // max name length is 20 bytes
                proposed_name = proposed_name.Substring(0, proposed_name.Length - 1);

            foreach (UserObject u in UserPool.Pool)
                if (u.Connected)
                    if (u.logged_in)
                        if (u.id != userobj.Id)
                            if (u.org_name == proposed_name || u.name == proposed_name)
                                return;

            foreach (WebUser u in WebPool.Pool)
                if (u.InUse)
                    if (u.LoggedIn)
                        if (u.OrgName == proposed_name || u.name == proposed_name)
                            return;

            userobj.name = proposed_name;
        }

        public static void FormatUsername(WebUser userobj, String proposed_name)
        {
            if (proposed_name == Settings.BotName)
                return;

            proposed_name = Regex.Replace(proposed_name, "_", " ", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "￼", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "­", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "\"", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "/", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, @"\\", "", RegexOptions.IgnoreCase);
            proposed_name = Regex.Replace(proposed_name, "www.", "", RegexOptions.IgnoreCase);

            if (userobj.name.Length < 2) // min name length is 2 bytes
                return;

            while (Encoding.UTF8.GetByteCount(proposed_name) > 20) // max name length is 20 bytes
                proposed_name = proposed_name.Substring(0, userobj.name.Length - 1);

            foreach (UserObject u in UserPool.Pool)
                if (u.Connected)
                    if (u.logged_in)
                        if (u.org_name == proposed_name || u.name == proposed_name)
                            return;

            foreach (WebUser u in WebPool.Pool)
                if (u.InUse)
                    if (u.LoggedIn)
                        if (u.Id != userobj.Id)
                            if (u.OrgName == proposed_name || u.name == proposed_name)
                                return;

            userobj.name = proposed_name;
        }

        public static bool IsTextFlood(IUser userobj)
        {
            last_typer.Add(userobj.ExternalIP);

            if (last_typer.Count > 8)
                last_typer.RemoveAt(0);

            int counter = 0;

            foreach (IPAddress n in last_typer)
                if (n.Equals(userobj.ExternalIP))
                    counter++;

            if (counter == 8) // flooding
            {
                last_typer.Clear();

                if (userobj.Level == 0 && !userobj.IsLocalHost)
                    return true;
            }

            return false;
        }

        public static void SoftenFlooding()
        {
            last_typer.Add(IPAddress.Any);

            if (last_typer.Count > 8)
                last_typer.RemoveAt(0);
        }

        public static CommandObject EvaluateClientCommandString(String cmdText)
        {
            CommandObject cmd = new CommandObject();
            cmd.cmdText = cmdText; // command text will be the full string no matter

            int first_space = cmdText.IndexOf(" ");

            if (first_space == -1)
                return cmd;

            cmdText = cmdText.Substring(first_space + 1); // removed command name

            if (cmdText.Length == 0)
                return cmd;

            // check right click command expression
            cmd.tUser = UserPool.FindUserByName(cmdText);

            if (cmd.tUser != null)
                return cmd;

            cmd.tUser = WebPool.FindUserByName(cmdText);

            if (cmd.tUser != null)
                return cmd;

            if (CallistoServer.Linker.IsLinking)
            {
                cmd.tUser = CallistoServer.Linker.linked_users.Find(l => l.name == cmdText);

                if (cmd.tUser != null)
                    return cmd;
            }

            if (cmdText.Substring(0, 1) == "\"") // looking for name in quotes method
            {
                cmdText = cmdText.Substring(1);
                int second_quote = cmdText.IndexOf("\"");

                if (second_quote <= 0)
                    return cmd;

                if (cmdText.Substring(0, second_quote).Length == 0)
                    return cmd;

                cmd.tUser = UserPool.FindUserByNameStartsWith(cmdText.Substring(0, second_quote));

                if (cmd.tUser == null)
                    cmd.tUser = WebPool.FindUserByNameStartsWith(cmdText.Substring(0, second_quote));

                if (cmd.tUser == null && CallistoServer.Linker.IsLinking)
                    cmd.tUser = CallistoServer.Linker.linked_users.Find(l => l.name.StartsWith(cmdText.Substring(0, second_quote)));

                cmdText = cmdText.Substring(second_quote + 1);

                if (cmdText.Length >= 2)
                    cmd.args = cmdText.Substring(1);
                else
                    cmd.args = String.Empty;

                return cmd;
            }
            else // looking for id method
            {
                int second_space = cmdText.IndexOf(" ");
                ushort eval_id;

                if (second_space <= 0) // no args
                {
                    if (!ushort.TryParse(cmdText, out eval_id))
                        return cmd;

                    cmd.tUser = UserPool.FindUserByID(eval_id);

                    if (cmd.tUser == null)
                        cmd.tUser = WebPool.FindUserByID(eval_id);

                    return cmd;
                }

                if (!ushort.TryParse(cmdText.Substring(0, second_space), out eval_id))
                    return cmd;

                cmd.tUser = UserPool.FindUserByID(eval_id);

                if (cmd.tUser == null)
                    cmd.tUser = WebPool.FindUserByID(eval_id);

                cmdText = cmdText.Substring(second_space);

                if (cmdText.Length >= 2)
                    cmd.args = cmdText.Substring(1);
                else
                    cmd.args = String.Empty;

                return cmd;
            }
        }

        public static String FileItemFormatName(byte[] data, byte mime, uint size)
        {
            AresPacketReader packet = new AresPacketReader(data);

            if (packet.Remaining() < 23)
                return null;

            ReceivedBrowseItem item = new ReceivedBrowseItem();
            item.Mime = mime;
            item.FileSize = size;
            packet.SkipBytes(16); // ignore - pre 2005 file guid, now uses SHA1

            switch (mime) // params
            {
                case 1: // audio
                    item.param1 = packet.ReadInt16(); // bit rate
                    item.param3 = packet.ReadInt16(); // duration
                    break;

                case 5: // video
                    item.param1 = packet.ReadInt16(); // bit rate
                    item.param2 = packet.ReadInt16(); // sample rate
                    item.param3 = packet.ReadInt16(); // duration
                    break;

                case 7: // image
                    item.param1 = packet.ReadInt16(); // width
                    item.param2 = packet.ReadInt16(); // height
                    item.param3 = packet.ReadByte(); // depth
                    break;
            }

            if (packet.Remaining() < 10)
                return null;

            packet.SkipBytes(2);

            while (packet.Remaining() > 2) // details
            {
                byte length = packet.ReadByte();
                byte type = packet.ReadByte();

                if (length > packet.Remaining())
                    return null;

                switch (type) // could make an object out of these !!
                {
                    case 1: // title
                        item.Title = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 2: // artist
                        item.Artist = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 3: // album
                        item.Album = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 4: // category
                        item.Category = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 5: // year
                        item.Year = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 6: // language
                        item.Language = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 7: // url
                        item.URL = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 8: // comment
                        item.Comment = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 9: // genre
                        item.Genre = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 10: // format
                        item.Format = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 15: // filename
                        item.FileName = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 20: // SHA1 hash
                        item.SHA1Hash = packet.ReadBytes(20);
                        break;

                    case 23: // path
                        item.Path = Encoding.UTF8.GetString(packet.ReadBytes(length));
                        break;

                    case 24: // size64
                        item.FileSize = packet.ReadInt64();
                        break;
                }
            }

            if (item.FileName.Length == 0) // malicious or badly formed file data
                return null;

            if (item.Title.Length == 0)
                item.Title = item.FileName;

            item.FileSizeString = item.FileSize > 1024 ? (item.FileSize / 1024).ToString("#,##0") + " KB" : item.FileSize.ToString();
            return item.FileName;
        }

        public static String CountryCodeToString(byte country)
        {
            switch (country)
            {
                case 1:
                    return "Afghanistan";
                case 2:
                    return "Albania";
                case 3:
                    return "Algeria";
                case 4:
                    return "Andorra";
                case 5:
                    return "Angola";
                case 6:
                    return "Anguilla";
                case 7:
                    return "Antarctia";
                case 8:
                    return "Antigua and Barbuda";
                case 9:
                    return "Argentina";
                case 10:
                    return "Armenia";
                case 11:
                    return "Aruba";
                case 12:
                    return "Australia";
                case 13:
                    return "Austria";
                case 14:
                    return "Azerbaijan";
                case 15:
                    return "Bahamas";
                case 16:
                    return "Bahrain";
                case 17:
                    return "Bangladesh";
                case 18:
                    return "Barbados";
                case 19:
                    return "Belarus";
                case 20:
                    return "Belgium";
                case 21:
                    return "Belize";
                case 22:
                    return "Berin";
                case 23:
                    return "Bermuda";
                case 24:
                    return "Bhutan";
                case 25:
                    return "Bolivia";
                case 26:
                    return "Bosnia and Herzegovina";
                case 27:
                    return "Botswana";
                case 28:
                    return "Brazil";
                case 29:
                    return "Brunei";
                case 30:
                    return "Bulgaria";
                case 31:
                    return "Burkina Faso";
                case 32:
                    return "Burundi";
                case 33:
                    return "Cambodia";
                case 34:
                    return "Cameroon";
                case 35:
                    return "Canada";
                case 36:
                    return "Cape Verde";
                case 37:
                    return "Cayman Islands";
                case 38:
                    return "Central African Republic";
                case 39:
                    return "Chad";
                case 40:
                    return "Chile";
                case 41:
                    return "China";
                case 42:
                    return "Christmas Islands";
                case 43:
                    return "Cocos Islands";
                case 44:
                    return "Colombia";
                case 45:
                    return "Comoros";
                case 46:
                    return "Congo";
                case 47:
                    return "Congo";
                case 48:
                    return "Cook Islands";
                case 49:
                    return "Costa Rica";
                case 50:
                    return "Croatia";
                case 51:
                    return "Cuba";
                case 52:
                    return "Cyprus";
                case 53:
                    return "Czech Republic";
                case 54:
                    return "Denmark";
                case 55:
                    return "Fjibouti";
                case 56:
                    return "Dominica";
                case 57:
                    return "Dominican Republic";
                case 58:
                    return "Dutch antilles";
                case 59:
                    return "East Timor";
                case 60:
                    return "Ecuador";
                case 61:
                    return "Egypt";
                case 62:
                    return "El Salvador";
                case 63:
                    return "Equatorial Guinea";
                case 64:
                    return "Entea";
                case 65:
                    return "Estonia";
                case 66:
                    return "Ethiopia";
                case 67:
                    return "Falkland Islands";
                case 68:
                    return "Faroe Islands";
                case 69:
                    return "Fiji Islands";
                case 70:
                    return "Finland";
                case 71:
                    return "France";
                case 72:
                    return "French Polynesia";
                case 73:
                    return "Gabon";
                case 74:
                    return "Gambia";
                case 75:
                    return "Gaza";
                case 76:
                    return "Georgia";
                case 77:
                    return "Germany";
                case 78:
                    return "Ghana";
                case 79:
                    return "Gibraltar";
                case 80:
                    return "Greece";
                case 81:
                    return "Greenland";
                case 82:
                    return "Grenada";
                case 83:
                    return "Geuadaloupe";
                case 84:
                    return "Guatemala";
                case 85:
                    return "Guernsey";
                case 86:
                    return "Guinea";
                case 87:
                    return "Guinea-Bissau";
                case 88:
                    return "Guyana";
                case 89:
                    return "Guyana";
                case 90:
                    return "Haiti";
                case 91:
                    return "Honduras";
                case 92:
                    return "Hong Kong";
                case 93:
                    return "Hungary";
                case 94:
                    return "Iceland";
                case 95:
                    return "India";
                case 96:
                    return "Indonesia";
                case 97:
                    return "Iran";
                case 98:
                    return "Iraq";
                case 99:
                    return "Ireland";
                case 100:
                    return "Isle of Man";
                case 101:
                    return "Israel";
                case 102:
                    return "Italy";
                case 103:
                    return "Ivory Coast";
                case 104:
                    return "Jamaica";
                case 105:
                    return "Japan";
                case 106:
                    return "Jersey";
                case 107:
                    return "Jordan";
                case 108:
                    return "Kazakhstan";
                case 109:
                    return "Kenya";
                case 110:
                    return "Kiribati";
                case 111:
                    return "Kuwwait";
                case 112:
                    return "Kyrgyzstan";
                case 113:
                    return "Laos";
                case 114:
                    return "Latvia";
                case 115:
                    return "Lebanon";
                case 116:
                    return "Lesotho";
                case 117:
                    return "Liberia";
                case 118:
                    return "Libya";
                case 119:
                    return "Liechtenstein";
                case 120:
                    return "Lithuania";
                case 121:
                    return "Luxembourg";
                case 122:
                    return "Macao";
                case 123:
                    return "Macedonia";
                case 124:
                    return "Madagascar";
                case 125:
                    return "Malawi";
                case 126:
                    return "Malaysia";
                case 127:
                    return "Maldives";
                case 128:
                    return "Mali";
                case 129:
                    return "Malta";
                case 130:
                    return "Marshall Islands";
                case 131:
                    return "Martinique";
                case 132:
                    return "Mauritania";
                case 133:
                    return "Mauritius";
                case 134:
                    return "Mayotte";
                case 135:
                    return "Mexico";
                case 136:
                    return "Micronesia";
                case 137:
                    return "Moldova";
                case 138:
                    return "Monaco";
                case 139:
                    return "Mongolia";
                case 140:
                    return "Montserrat";
                case 141:
                    return "Morocco";
                case 142:
                    return "Mozambique";
                case 143:
                    return "Myanmar";
                case 144:
                    return "Namibia";
                case 145:
                    return "Nauru";
                case 146:
                    return "Nepal";
                case 147:
                    return "Netherlands";
                case 148:
                    return "New Caledonia";
                case 149:
                    return "New Zealand";
                case 150:
                    return "Nicaragua";
                case 151:
                    return "Niger";
                case 152:
                    return "Nigeria";
                case 153:
                    return "Niue";
                case 154:
                    return "Norfolk Island";
                case 155:
                    return "North Korea";
                case 156:
                    return "Norway";
                case 157:
                    return "Oman";
                case 158:
                    return "Pakistan";
                case 159:
                    return "Palau";
                case 160:
                    return "Panama";
                case 161:
                    return "Papua New Guinea";
                case 162:
                    return "Paraguay";
                case 163:
                    return "Peru";
                case 164:
                    return "Phillippines";
                case 165:
                    return "Pitcairn Island";
                case 166:
                    return "Poland";
                case 167:
                    return "Portugal";
                case 168:
                    return "Puerto Rico";
                case 169:
                    return "Qatar";
                case 170:
                    return "Reunion";
                case 171:
                    return "Romania";
                case 172:
                    return "Russia";
                case 173:
                    return "Rwanda";
                case 174:
                    return "Samoa";
                case 175:
                    return "San Marino";
                case 176:
                    return "Sao Tome and Principe";
                case 177:
                    return "Saudi Arabia";
                case 178:
                    return "Senegal";
                case 179:
                    return "Seychelles";
                case 180:
                    return "Sierra Leone";
                case 181:
                    return "Singapore";
                case 182:
                    return "Slovakia";
                case 183:
                    return "Slovenia";
                case 184:
                    return "Solomon Island";
                case 185:
                    return "Somalia";
                case 186:
                    return "South Africa";
                case 187:
                    return "South Georgia Island";
                case 188:
                    return "South Korea";
                case 189:
                    return "Spain";
                case 190:
                    return "Sri Lanka";
                case 191:
                    return "St Helens";
                case 192:
                    return "St Kitts and Nevis";
                case 193:
                    return "St Lucia";
                case 194:
                    return "St Pierre and Miquelon";
                case 195:
                    return "St Vicent";
                case 196:
                    return "Sudan";
                case 197:
                    return "Suriname";
                case 198:
                    return "Svalbard";
                case 199:
                    return "Swaziland";
                case 200:
                    return "Sweden";
                case 201:
                    return "Switzerland";
                case 202:
                    return "Syria";
                case 203:
                    return "Taiwan";
                case 204:
                    return "Tajikistan";
                case 205:
                    return "Tanzania";
                case 206:
                    return "Thailand";
                case 207:
                    return "Togo";
                case 208:
                    return "Tokelau";
                case 209:
                    return "Tonga";
                case 210:
                    return "Trinidad and Tobago";
                case 211:
                    return "Tunisia";
                case 212:
                    return "Turkey";
                case 213:
                    return "Turkmenistan";
                case 214:
                    return "Turks and Caicos Islands";
                case 215:
                    return "Tuvalu";
                case 216:
                    return "Uganda";
                case 217:
                    return "Ukraine";
                case 218:
                    return "United Arab Emirates";
                case 219:
                    return "United Kingdom";
                case 220:
                    return "United States";
                case 221:
                    return "Uruguay";
                case 222:
                    return "Uzbekistan";
                case 223:
                    return "Vanuatu";
                case 224:
                    return "Venezuela";
                case 225:
                    return "Vietnam";
                case 226:
                    return "Virgin Islands";
                case 227:
                    return "Wallis and Futuna";
                case 228:
                    return "West Bank";
                case 229:
                    return "Western Sahara";
                case 230:
                    return "Yemen";
                case 231:
                    return "Yugoslavia";
                case 232:
                    return "Zambia";
                case 233:
                    return "Zimbabwe";
            }

            return "Unknown";
        }
    }

    class ReceivedBrowseItem
    {
        public byte Mime = 0;
        public ulong FileSize = 0;
        public ushort param1 = 0;
        public ushort param2 = 0;
        public ushort param3 = 0;
        public String Title = String.Empty;
        public String Artist = String.Empty;
        public String Album = String.Empty;
        public String Category = String.Empty;
        public String Year = String.Empty;
        public String Language = String.Empty;
        public String URL = String.Empty;
        public String Comment = String.Empty;
        public String Genre = String.Empty;
        public String Format = String.Empty;
        public String FileName = String.Empty;
        public String Path = String.Empty;
        public String FileSizeString = String.Empty;
        public byte[] SHA1Hash;
    }
}
