﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ICallisto;

namespace callisto
{
    public partial class AdminSystemScreen : UserControl
    {
        public AdminSystemScreen()
        {
            InitializeComponent();
        }

        public void SetValues()
        {
            this.listView1.Items.AddRange(Passwords.Items.ToArray());
            this.ClearValues();
        }

        private void ClearValues()
        {
            this.textBox1.Clear();
            this.textBox2.Clear();
            this.comboBox1.SelectedIndex = 0;
        }

        private void button1_Click(object sender, EventArgs e) // add new item
        {
            PasswordItem i = new PasswordItem();

            String str = this.textBox1.Text.Trim();
            this.textBox1.Text = str;

            if (str.Length < 2 || str.Length > 20)
            {
                MessageBox.Show("Username must be between 2 and 20 characters");
                return;
            }

            i.Username = str;
            str = this.textBox2.Text.Trim();
            this.textBox2.Text = str;

            if (str.Length < 2 || str.Length > 20)
            {
                MessageBox.Show("Password must be between 2 and 20 characters");
                return;
            }
            
            i.Password = textBox2.Text;
            i.Level = (AdminLevel)(comboBox1.SelectedIndex + 1);

            if (Passwords.Items.Contains(i))
            {
                MessageBox.Show("This password is already in use");
                return;
            }

            Passwords.Items.Add(i);
            Passwords.Save();
            this.listView1.Items.Add(i);
            this.ClearValues();
        }

        private void removeToolStripMenuItem_Click(object sender, EventArgs e) // remove item
        {
            if (this.listView1.SelectedIndices.Count > 0)
            {
                PasswordItem i = (PasswordItem)this.listView1.Items[this.listView1.SelectedIndices[0]];
                Passwords.Items.RemoveAll(x => x.Password == i.Password);
                Passwords.Save();
                this.listView1.Items.RemoveAt(this.listView1.SelectedIndices[0]);
            }
        }
    }
}
