﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Microsoft.Win32;

namespace callisto
{
    public partial class CallistoScreen : UserControl
    {
        public CallistoScreen()
        {
            InitializeComponent();
        }

        public delegate void CallistoStatusDelegate(bool enabled);
        public event CallistoStatusDelegate OnStatusChanged;

        public delegate void CallistoRestartDelegate();
        public event CallistoRestartDelegate OnRestart;

        public void SetValues()
        {
            this.checkBox2.Checked = Settings.auto_load;
            this.checkBox3.Checked = Settings.auto_start;
            this.SetAutoLoad();

            if (Settings.auto_start)
            {
                this.button1.Enabled = false;
                this.button2.Enabled = true;
                this.button3.Enabled = true;
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                Process.Start("http://sharptricks.wordpress.com/");
            }
            catch { }
        }

        private void button1_Click(object sender, EventArgs e) // start
        {
            this.OnStatusChanged(true);
            this.button1.Enabled = false;
            this.button2.Enabled = true;
            this.button3.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e) // stop
        {
            this.OnStatusChanged(false);
            this.button1.Enabled = true;
            this.button2.Enabled = false;
            this.button3.Enabled = false;
        }

        private void button3_Click(object sender, EventArgs e) // restart
        {
            this.OnRestart();
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e) // auto load
        {
            Settings.auto_load = this.checkBox2.Checked;
            Settings.Save();
            this.SetAutoLoad();
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e) // auto start
        {
            Settings.auto_start = this.checkBox3.Checked;
            Settings.Save();
        }

        private void SetAutoLoad()
        {
            try
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey("Software\\Microsoft\\Windows\\CurrentVersion\\RunOnce", true);
                String path = AppDomain.CurrentDomain.BaseDirectory;
                String program_name = Process.GetCurrentProcess().ProcessName;

                if (Settings.auto_load) // check that value exists and correct
                {
                    key.SetValue(program_name, path + program_name + ".exe");
                }
                else // check that value does not exist
                {
                    if (key.GetValue(program_name, null) != null)
                        key.DeleteValue(program_name);
                }

                key.Close();
            }
            catch { }
        }

    }
}
