﻿using System;
using System.Windows.Forms;

namespace callisto
{
    public partial class ChannelListingScreen : UserControl
    {
        private int time = 900;
        private int c_req = 0;
        private int s_req = 0;
        private int s_res = 0;

        private delegate void SetLabelValueDelegate(object label, String str);

        public ChannelListingScreen()
        {
            InitializeComponent();
        }

        public void SetValues()
        {
            this.checkBox1.Checked = Settings.ShouldList;
        }

        public void UpdateStats()
        {
            this.time--;
            this.c_req += ChannelListUpdateArgs.ClientRequests;
            this.s_req += ChannelListUpdateArgs.ServerRequests;
            this.s_res += ChannelListUpdateArgs.ServerResponses;

            ChannelListUpdateArgs.ClientRequests = 0;
            ChannelListUpdateArgs.ServerRequests = 0;
            ChannelListUpdateArgs.ServerResponses = 0;

            if (this.time == 0)
            {
                this.time = 900;
                this.c_req = 0;
                this.s_req = 0;
                this.s_res = 0;
            }

            this.UpdateStats(true);
        }

        private void UpdateStats(bool x)
        {
            int mins = this.time / 60;
            int secs = this.time - (mins * 60);
            String str = (mins.ToString().Length == 1 ? ("0" + mins) : mins.ToString());
            str += ":";
            str += (secs.ToString().Length == 1 ? ("0" + secs) : secs.ToString());
            this.SetLabelValue(this.label1, "Timer Elapse: " + str);

            str = this.c_req.ToString();

            while (str.Length < 5)
                str = "0" + str;

            this.SetLabelValue(this.label2, "Client Requests: " + str);

            str = this.s_req.ToString();

            while (str.Length < 3)
                str = "0" + str;

            this.SetLabelValue(this.label3, "Server Requests: " + str);

            str = this.s_res.ToString();

            while (str.Length < 3)
                str = "0" + str;

            this.SetLabelValue(this.label4, "Server Responses: " + str);
        }

        private void SetLabelValue(object label, String str)
        {
            Label l = (Label)label;

            if (l.InvokeRequired)
                l.BeginInvoke(new SetLabelValueDelegate(this.SetLabelValue), label, str);
            else l.Text = str;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e) // toggle channel listing
        {
            Settings.ShouldList = this.checkBox1.Checked;
            Settings.Save();
        }
    }
}
