﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ICallisto;

namespace callisto
{
    public partial class RoomLinkingScreen : UserControl
    {
        public RoomLinkingScreen()
        {
            InitializeComponent();
        }

        public void SetValues()
        {
            this.checkBox1.Checked = Settings.RoomLinking;
            this.checkBox2.Checked = Settings.AdminLinking;

            foreach (TrustedServerItems i in TrustedServers.Items)
                this.listBox1.Items.Add(i.Name);
        }

        private void button1_Click(object sender, EventArgs e) // add a new room
        {
            ChannelObject c = HashlinkHelpers.DecodeHashlink(this.textBox1.Text.Trim());

            if (c == null)
            {
                MessageBox.Show("Invalid hashlink");
                return;
            }

            TrustedServerItems i = new TrustedServerItems(c);

            if (TrustedServers.Items.Contains(i))
            {
                int index = TrustedServers.Items.FindIndex(x => x.Name == i.Name);
                TrustedServers.Items[index].IP = i.IP;
                TrustedServers.Items[index].Port = i.Port;
                TrustedServers.Save();
            }
            else
            {
                TrustedServers.Items.Add(i);
                TrustedServers.Save();
                this.listBox1.Items.Add(i.Name);
            }

            this.textBox1.Text = "arlnk://";
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e) // toggle room linking
        {
            Settings.RoomLinking = this.checkBox1.Checked;
            Settings.Save();
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e) // toggle admin linking
        {
            Settings.AdminLinking = this.checkBox2.Checked;

            if (Settings.Save())
                if (this.checkBox2.Checked)
                    MessageBox.Show("Allowing linked admins to control your room can be risky.  Please only enable this option if you trust the room you are linked to.",
                        "Callisto Linking", MessageBoxButtons.OK, MessageBoxIcon.Warning);
        }

        private void removeToolStripMenuItem_Click(object sender, EventArgs e) // remove a room
        {
            if (this.listBox1.SelectedIndex > -1)
            {
                String str = (String)this.listBox1.Items[this.listBox1.SelectedIndex];
                TrustedServers.Items.RemoveAll(x => x.Name == str);
                TrustedServers.Save();
                this.listBox1.Items.RemoveAt(this.listBox1.SelectedIndex);
            }
        }
    }
}
