﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;

namespace callisto
{
    public partial class RoomSettingsScreen : UserControl
    {
        private ToolTip tip = new ToolTip();

        public RoomSettingsScreen()
        {
            InitializeComponent();
        }

        public void SetValues()
        {
            this.textBox1.Text = Settings.ServerName;
            this.textBox2.Text = Settings.ServerPort.ToString();
            this.textBox3.Text = Settings.ServerTopic;
            this.textBox4.Text = Settings.udp_ip.Equals(IPAddress.Any) ? String.Empty : Settings.udp_ip.ToString();
            this.textBox5.Text = Settings.BotName;
            this.checkBox1.Checked = Settings.enable_vc;
            this.checkBox3.Checked = Settings.allow_dc;
            this.checkBox4.Checked = Settings.allow_custom_emotes;
            this.comboBox1.SelectedIndex = Settings.ServerLanguage;
            this.checkBox5.Checked = Settings.allow_silverlight;
            this.checkBox6.Checked = Settings.ban_spambots;
            this.checkBox7.Checked = Settings.local_auto_login;
            this.checkBox8.Checked = Settings.allow_filesharing;
            this.checkBox2.Checked = Settings.allow_room_scribbles;
        }

        public void SetReadOnly(bool enabled)
        {
            this.textBox1.Enabled = enabled;
            this.textBox2.Enabled = enabled;
            this.textBox3.Enabled = enabled;
            this.textBox4.Enabled = enabled;
            this.textBox5.Enabled = enabled;
            this.comboBox1.Enabled = enabled;
            this.checkBox1.Enabled = enabled;
            this.checkBox3.Enabled = enabled;
            this.checkBox4.Enabled = enabled;
            this.checkBox5.Enabled = enabled;
            this.checkBox6.Enabled = enabled;
            this.checkBox7.Enabled = enabled;
            this.checkBox8.Enabled = enabled;
            this.checkBox2.Enabled = enabled;
        }

        private void textBox3_MouseHover(object sender, EventArgs e)
        {

        }

        private void textBox3_MouseLeave(object sender, EventArgs e) // topic
        {
            String str = textBox3.Text;

            while (Encoding.UTF8.GetByteCount(str) > 180)
                str = str.Substring(0, str.Length - 1);

            if (str.Length < 2)
            {
                this.textBox3.Text = Settings.ServerTopic;
                return;
            }

            this.textBox3.Text = str;
            Settings._topic = str;
            Settings.Save();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e) // language
        {
            Settings.ServerLanguage = this.comboBox1.SelectedIndex;
            Settings.Save();
        }

        private delegate void CheckTopicDelegate();

        public void CheckTopic()
        {
            if (this.textBox3.InvokeRequired)
                this.textBox3.BeginInvoke(new CheckTopicDelegate(this.CheckTopic));
            else if (Settings.ServerTopic != this.textBox3.Text)
                this.textBox3.Text = Settings.ServerTopic;
        }

        private void textBox2_MouseLeave(object sender, EventArgs e) // port
        {
            ushort i;
            String str = textBox2.Text.Trim();

            if (!ushort.TryParse(str, out i))
            {
                this.textBox2.Text = Settings.ServerPort.ToString();
                return;
            }

            this.textBox2.Text = str;
            Settings.ServerPort = i;
            Settings.Save();
        }

        private void textBox1_MouseLeave(object sender, EventArgs e) // name
        {
            String str = textBox1.Text.Trim();

            while (Encoding.UTF8.GetByteCount(str) > 30)
                str = str.Substring(0, str.Length - 1);

            if (str.Length < 2)
            {
                this.textBox1.Text = Settings.ServerTopic;
                return;
            }

            this.textBox1.Text = str;
            Settings.ServerName = str;
            Settings.Save();
        }

        private void RoomSettingsScreen_VisibleChanged(object sender, EventArgs e)
        {
            if (!this.Visible)
            {
                String str = textBox1.Text.Trim();

                while (Encoding.UTF8.GetByteCount(str) > 30)
                    str = str.Substring(0, str.Length - 1);

                if (str.Length < 2)
                {
                    this.textBox1.Text = Settings.ServerTopic;
                }
                else
                {
                    this.textBox1.Text = str;
                    Settings.ServerName = str;
                }

                ushort i;
                str = textBox2.Text.Trim();

                if (!ushort.TryParse(str, out i))
                {
                    this.textBox2.Text = Settings.ServerPort.ToString();
                }
                else
                {
                    this.textBox2.Text = str;
                    Settings.ServerPort = i;
                }

                str = textBox3.Text;

                while (Encoding.UTF8.GetByteCount(str) > 180)
                    str = str.Substring(0, str.Length - 1);

                if (str.Length < 2)
                {
                    this.textBox3.Text = Settings.ServerTopic;
                }
                else
                {
                    this.textBox3.Text = str;
                    Settings._topic = str;
                }

                IPAddress ip;

                if (this.textBox4.Text.Length > 0)
                {
                    if (IPAddress.TryParse(this.textBox4.Text, out ip))
                        Settings.udp_ip = ip;
                    else
                    {
                        Settings.udp_ip = IPAddress.Any;
                        this.textBox4.Clear();
                    }
                }
                else Settings.udp_ip = IPAddress.Any;

                Settings.Save();
            }
        }

        private void textBox4_MouseHover(object sender, EventArgs e)
        {
            this.tip = new ToolTip();
            this.tip.SetToolTip(this.textBox4, "This setting should be left blank\r\nunless specifically required");
        }

        private void textBox4_MouseLeave(object sender, EventArgs e)
        {
            this.tip.Dispose();
            IPAddress ip;

            if (this.textBox4.Text.Length > 0)
            {
                if (IPAddress.TryParse(this.textBox4.Text, out ip))
                    Settings.udp_ip = ip;
                else
                {
                    Settings.udp_ip = IPAddress.Any;
                    this.textBox4.Clear();
                }
            }
            else Settings.udp_ip = IPAddress.Any;
            Settings.Save();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            Settings.enable_vc = this.checkBox1.Checked;
            Settings.Save();
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            Settings.allow_dc = this.checkBox3.Checked;
            Settings.Save();
        }

        private void textBox5_MouseLeave(object sender, EventArgs e)
        {
            String str = this.textBox5.Text;
            int len = Encoding.UTF8.GetByteCount(str);

            if (len > 20 || len < 2)
                str = "Callisto";

            this.textBox5.Text = str;
            Settings.BotName = str;
            Settings.Save();
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            Settings.allow_custom_emotes = this.checkBox4.Checked;
            Settings.Save();
        }

        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            Settings.allow_silverlight = this.checkBox5.Checked;
            Settings.Save();
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e) // spam bots
        {
            Settings.ban_spambots = this.checkBox6.Checked;
            Settings.Save();
        }

        private void checkBox7_CheckedChanged(object sender, EventArgs e)
        {
            Settings.local_auto_login = this.checkBox7.Checked;
            Settings.Save();
        }

        private void checkBox8_CheckedChanged(object sender, EventArgs e)
        {
            Settings.allow_filesharing = this.checkBox8.Checked;
            Settings.Save();
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            Settings.allow_room_scribbles = this.checkBox2.Checked;
            Settings.Save();
        }
    }
}
