﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;

namespace callisto
{
    public partial class ScriptingScreen : UserControl
    {
        private ToolTip tip;

        public ScriptingScreen()
        {
            InitializeComponent();
            this.tip = new ToolTip();
            this.tip.AutoPopDelay = 10000;
            this.tip.InitialDelay = 500;
            this.tip.ReshowDelay = 500;
            this.tip.ShowAlways = true;
        }

        public void SetValues()
        {
            this.comboBox1.SelectedIndex = (Settings.script_level - 1);
            this.checkBox1.Checked = Settings.js_enabled;
            this.checkBox3.Checked = Settings.js_inroom_enabled;
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                Process.Start("http://spidermonkeydotnet.codeplex.com/");
            }
            catch { }
        }

        private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                Process.Start(Settings.Path + "Scripts");
            }
            catch { }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e) // enable js
        {
            Settings.js_enabled = this.checkBox1.Checked;
            Settings.Save();
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e) // enable Script.eval
        {
            Settings.js_inroom_enabled = this.checkBox3.Checked;
            Settings.Save();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e) // script level
        {
            Settings.script_level = (this.comboBox1.SelectedIndex + 1);
            Settings.Save();
        }

        private void linkLabel1_MouseEnter(object sender, EventArgs e)
        {
            this.tip.SetToolTip(this.linkLabel1, "Link worthy\r\n\r\nAdd JS Scripting to your C# applications\r\nwith this cool library by ¦ธιใ√εя¦");
        }

        private void linkLabel3_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            DialogResult dr = MessageBox.Show("This will create fresh copies of Callisto's default scripts, overwriting older copies you may have installed.  Are you sure you wish to continue?",
                "Callisto Script Builder", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            if (dr == DialogResult.Yes)
            {
                this.BuildBlankScript();
                this.BuildLiveScript();
                this.BuildAutorunScript();
            }
        }

        private void BuildBlankScript()
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("function onTextReceived(userobj, text) { }");
            sb.AppendLine("function onTextBefore(userobj, text) { return text; }");
            sb.AppendLine("function onTextAfter(userobj, text) { }");
            sb.AppendLine("function onEmoteReceived(userobj, text) { }");
            sb.AppendLine("function onEmoteBefore(userobj, text) { return text; }");
            sb.AppendLine("function onEmoteAfter(userobj, text) { }");
            sb.AppendLine("function onError(script, line, message) { }");
            sb.AppendLine("function onJoinCheck(userobj) { return true; }");
            sb.AppendLine("function onJoin(userobj) { }");
            sb.AppendLine("function onPart(userobj) { }");
            sb.AppendLine("function onTimer() { }");
            sb.AppendLine("function onHelp(userobj) { }");
            sb.AppendLine("function onCommand(userobj, command, target, args) { }");
            sb.AppendLine("function onAvatar(userobj) { return true; }");
            sb.AppendLine("function onPersonalMessage(userobj) { return true; }");
            sb.AppendLine("function onRejected(userobj) { }");
            sb.AppendLine("function onLoad() { }");
            sb.AppendLine("function onUnload() { }");
            sb.AppendLine("function onVroomJoinCheck(userobj, vroom) { return true; }");
            sb.AppendLine("function onVroomJoin(userobj) { }");
            sb.AppendLine("function onVroomPart(userobj) { }");
            sb.AppendLine("function onLoginAttempted(userobj, success) { }");
            sb.AppendLine("function onFileReceived(userobj, filename) { }");
            sb.AppendLine("function onFlood(userobj) { return true; }");
            sb.AppendLine("function onBotPM(userobj, text) { return true; }");
            sb.AppendLine("function onPM(userobj, target, pm) { return true; }");
            sb.AppendLine("function onLinkConnected(link) { }");
            sb.AppendLine("function onLinkDisconnected(link) { }");
            sb.AppendLine("function onLinkError(link, code) { }");
            sb.AppendLine("function onLinkCommand(userobj, command, target, args) { }");
            sb.AppendLine();

            try
            {
                if (!Directory.Exists(Settings.Path + "Scripts\\blank.js"))
                    Directory.CreateDirectory(Settings.Path + "Scripts\\blank.js");

                File.WriteAllText(Settings.Path + "Scripts\\blank.js\\blank.js", sb.ToString());
            }
            catch { }
        }

        private void BuildAutorunScript()
        {
            String path = Settings.Path + "scriptloader";
            String result = "live.js";

            try
            {
                File.WriteAllText(path, result);
            }
            catch { }
        }

        private void BuildLiveScript()
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("print(\"livescript interface script - by oobe\");");
            sb.AppendLine("");
            sb.AppendLine("var downloads = [];");
            sb.AppendLine("");
            sb.AppendLine("String.prototype.startsWith = function (str)");
            sb.AppendLine("{");
            sb.AppendLine("    if (this.length < str.length)");
            sb.AppendLine("        return false;");
            sb.AppendLine("");
            sb.AppendLine("    return this.substr(0, str.length) == str;");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("Array.prototype.removeAt = function (index)");
            sb.AppendLine("{");
            sb.AppendLine("    for (var i = index; i < this.length; i++)");
            sb.AppendLine("    {");
            sb.AppendLine("        if (i < (this.length - 1))");
            sb.AppendLine("            this[i] = this[i + 1];");
            sb.AppendLine("        else this.pop();");
            sb.AppendLine("    }");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("Array.prototype.findIndex = function (str)");
            sb.AppendLine("{");
            sb.AppendLine("    for (var i = 0; i < this.length; i++)");
            sb.AppendLine("        if (downloads[i].name == str)");
            sb.AppendLine("            return i;");
            sb.AppendLine("");
            sb.AppendLine("    return -1;");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function onTimer()");
            sb.AppendLine("{");
            sb.AppendLine("    var time = Math.floor(new Date().getTime() / 1000);");
            sb.AppendLine("");
            sb.AppendLine("    if (downloads.length > 0)");
            sb.AppendLine("    {");
            sb.AppendLine("        for (var i = (downloads.length - 1); i > -1; i--)");
            sb.AppendLine("            if (downloads[i].time < (time - 15))");
            sb.AppendLine("            {");
            sb.AppendLine("                print(\"timed out attempting to download script: \" + downloads[i].name);");
            sb.AppendLine("                downloads.removeAt(i);");
            sb.AppendLine("            }");
            sb.AppendLine("    }");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function onHelp(userobj)");
            sb.AppendLine("{");
            sb.AppendLine("    if (canScript(userobj))");
            sb.AppendLine("    {");
            sb.AppendLine("        print(userobj, \"#livescripts    -    shows a list of all scripts available for download\");");
            sb.AppendLine("        print(userobj, \"#downloadscript <scriptname>    -    download a script\");");
            sb.AppendLine("    }");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function onHttpReceived(e)");
            sb.AppendLine("{");
            sb.AppendLine("    var args = this.arg.split(\":\");");
            sb.AppendLine("");
            sb.AppendLine("    if (e)");
            sb.AppendLine("    {");
            sb.AppendLine("        switch (args[0])");
            sb.AppendLine("        {");
            sb.AppendLine("            case \"list\":");
            sb.AppendLine("                onListReceived(this.page, args[1]);");
            sb.AppendLine("                break;");
            sb.AppendLine("");
            sb.AppendLine("            case \"download\":");
            sb.AppendLine("                onDownloadReceived(this.page, args[1]);");
            sb.AppendLine("                break;");
            sb.AppendLine("");
            sb.AppendLine("            case \"file\":");
            sb.AppendLine("                onScriptFileReceived(this.page, args[1], args[2]);");
            sb.AppendLine("                break;");
            sb.AppendLine("        }");
            sb.AppendLine("    }");
            sb.AppendLine("    else if (args[0] == \"download\")");
            sb.AppendLine("    {");
            sb.AppendLine("        print(\"unable to download script: \" + args[1]);");
            sb.AppendLine("        var i = downloads.findIndex(args[1]);");
            sb.AppendLine("");
            sb.AppendLine("        if (i > -1)");
            sb.AppendLine("            downloads.removeAt(i);");
            sb.AppendLine("    }");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function onListReceived(page, target)");
            sb.AppendLine("{");
            sb.AppendLine("    var userobj = user(target);");
            sb.AppendLine("");
            sb.AppendLine("    if (userobj != null)");
            sb.AppendLine("    {");
            sb.AppendLine("        var lines = page.split(\"\\r\\n\");");
            sb.AppendLine("");
            sb.AppendLine("        for (var i = 0; i < lines.length; i++)");
            sb.AppendLine("            print(userobj, lines[i]);");
            sb.AppendLine("    }");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function onDownloadReceived(page, script)");
            sb.AppendLine("{");
            sb.AppendLine("    var d = new Downloader();");
            sb.AppendLine("    d.name = script;");
            sb.AppendLine("    var files = page.split(\"\\r\\n\");");
            sb.AppendLine("");
            sb.AppendLine("    for (var i = 0; i < files.length; i++)");
            sb.AppendLine("    {");
            sb.AppendLine("        var f = files[i].split(\":\");");
            sb.AppendLine("        d.fileList.push({ type: f[0], name: f[1] });");
            sb.AppendLine("    }");
            sb.AppendLine("");
            sb.AppendLine("    downloads.push(d);");
            sb.AppendLine("");
            sb.AppendLine("    var http = new HttpRequest();");
            sb.AppendLine("    http.src = \"http://chatrooms.marsproject.net/livescript/callisto.aspx?action=download&script=\" + script + \"&name=\" + d.fileList[0].name;");
            sb.AppendLine("    http.oncomplete = onHttpReceived;");
            sb.AppendLine("    http.download(\"file:\" + script + \":\" + d.fileList[0].name);");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function onScriptFileReceived(page, script, file)");
            sb.AppendLine("{");
            sb.AppendLine("    var i = downloads.findIndex(script);");
            sb.AppendLine("");
            sb.AppendLine("    if (i > -1)");
            sb.AppendLine("    {");
            sb.AppendLine("        var type = downloads[i].fileList[0].type;");
            sb.AppendLine("");
            sb.AppendLine("        if (type == \"script\")");
            sb.AppendLine("        {");
            sb.AppendLine("            if (script == file)");
            sb.AppendLine("                Script.write(script, page);");
            sb.AppendLine("            else");
            sb.AppendLine("                Script.writeInclude(script, file, page);");
            sb.AppendLine("        }");
            sb.AppendLine("        else if (type == \"data\")");
            sb.AppendLine("            File.save(file, script, page);");
            sb.AppendLine("");
            sb.AppendLine("        downloads[i].fileList.shift();");
            sb.AppendLine("");
            sb.AppendLine("        if (downloads[i].fileList.length > 0)");
            sb.AppendLine("        {");
            sb.AppendLine("            var http = new HttpRequest();");
            sb.AppendLine("            http.src = \"http://chatrooms.marsproject.net/livescript/callisto.aspx?action=download&script=\" + script + \"&name=\" + downloads[i].fileList[0].name;");
            sb.AppendLine("            http.oncomplete = onHttpReceived;");
            sb.AppendLine("            http.download(\"file:\" + script + \":\" + downloads[i].fileList[0].name);");
            sb.AppendLine("        }");
            sb.AppendLine("        else");
            sb.AppendLine("        {");
            sb.AppendLine("            downloads.removeAt(i);");
            sb.AppendLine("            Script.load(script);");
            sb.AppendLine("        }");
            sb.AppendLine("    }");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function onCommand(userobj, command, target, args)");
            sb.AppendLine("{");
            sb.AppendLine("    if (canScript(userobj))");
            sb.AppendLine("    {");
            sb.AppendLine("        if (command == \"livescripts\")");
            sb.AppendLine("        {");
            sb.AppendLine("            var http = new HttpRequest();");
            sb.AppendLine("            http.src = \"http://chatrooms.marsproject.net/livescript/callisto.aspx?action=list\";");
            sb.AppendLine("            http.oncomplete = onHttpReceived;");
            sb.AppendLine("            http.download(\"list:\" + userobj.name);");
            sb.AppendLine("        }");
            sb.AppendLine("        else if (command.startsWith(\"downloadscript \"))");
            sb.AppendLine("        {");
            sb.AppendLine("            var http = new HttpRequest();");
            sb.AppendLine("            http.src = \"http://chatrooms.marsproject.net/livescript/callisto.aspx?action=files&name=\" + command.substr(15);");
            sb.AppendLine("            http.oncomplete = onHttpReceived;");
            sb.AppendLine("            http.download(\"download:\" + command.substr(15));");
            sb.AppendLine("        }");
            sb.AppendLine("    }");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("function Downloader()");
            sb.AppendLine("{");
            sb.AppendLine("    this.time = Math.floor(new Date().getTime() / 1000);");
            sb.AppendLine("    this.name = \"\";");
            sb.AppendLine("    this.fileList = [];");
            sb.AppendLine("}");
            sb.AppendLine("");

            try
            {
                if (!Directory.Exists(Settings.Path + "Scripts\\live.js"))
                    Directory.CreateDirectory(Settings.Path + "Scripts\\live.js");

                File.WriteAllText(Settings.Path + "Scripts\\live.js\\live.js", sb.ToString());
            }
            catch { }
        }
    }
}
