﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml;
using ICallisto;

namespace callisto
{
    class Passwords
    {
        public static List<PasswordItem> Items;

        public static void Load()
        {
            Items = new List<PasswordItem>();

            try
            {
                FileStream f = new FileStream(Settings.Path + "passwords.xml", FileMode.Open);
                XmlReader xml = XmlReader.Create(new StreamReader(f));

                xml.MoveToContent();
                xml.ReadSubtree().ReadToFollowing("passwords");

                while (xml.ReadToFollowing("item"))
                {
                    PasswordItem a = new PasswordItem();

                    xml.ReadSubtree().ReadToFollowing("name");
                    a.Username = Encoding.UTF8.GetString(Convert.FromBase64String(xml.ReadElementContentAsString()));
                    xml.ReadToFollowing("password");
                    a.Password = Encoding.UTF8.GetString(Convert.FromBase64String(xml.ReadElementContentAsString()));
                    xml.ReadToFollowing("level");
                    a.Level = (AdminLevel)xml.ReadElementContentAsInt();

                    Items.Add(a);
                }

                xml.Close();
                f.Flush();
                f.Close();
            }
            catch { }
        }

        public static void Save()
        {
            try
            {
                XmlWriterSettings appearance = new XmlWriterSettings();
                appearance.Indent = true;
                XmlWriter xml = XmlWriter.Create(Settings.Path + "passwords.xml", appearance);

                xml.WriteStartDocument();
                xml.WriteStartElement("passwords");

                foreach (PasswordItem a in Items)
                {
                    xml.WriteStartElement("item");
                    xml.WriteElementString("name", Convert.ToBase64String(Encoding.UTF8.GetBytes(a.Username)));
                    xml.WriteElementString("password", Convert.ToBase64String(Encoding.UTF8.GetBytes(a.Password)));
                    xml.WriteElementString("level", ((int)a.Level).ToString());
                    xml.WriteEndElement();
                }

                xml.WriteEndElement();
                xml.WriteEndDocument();
                xml.Flush();
                xml.Close();
            }
            catch { }
        }
    }
}
