﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;
using Jurassic.Library;
using ICallisto;

namespace callisto.Scripting.Objects
{
    class HashlinkResult : ObjectInstance
    {
        internal IChannelObject parent;

        public HashlinkResult(ObjectInstance prototype, IChannelObject obj)
            : base(prototype)
        {
            this.PopulateFunctions();
            this.parent = obj;
        }

        [JSProperty(Name = "name")]
        public String Name
        {
            get { return this.parent.Name; }
            set { }
        }

        [JSProperty(Name = "ip")]
        public String ExternalIP
        {
            get { return this.parent.ExternalIP.ToString(); }
            set { }
        }

        [JSProperty(Name = "port")]
        public int Port
        {
            get { return this.parent.Port; }
            set { }
        }

        public override string ToString()
        {
            return "[object HashlinkResult]";
        }
    }
}
