﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;
using Jurassic.Library;
using ICallisto;

namespace callisto.Scripting.Objects
{
    class IgnoreCollection : ObjectInstance
    {
        private int count { get; set; }

        public IgnoreCollection(ObjectInstance prototype, String[] ignores, String scriptName)
            : base(prototype)
        {
            this.PopulateFunctions();
            this.count = 0;

            CallistoScript script = ScriptManager.Scripts.Find(x => x.ScriptName == scriptName);

            if (script != null)
            {
                foreach (String str in ignores)
                    if (!String.IsNullOrEmpty(str))
                    {
                        User u = script.local_users.Find(x => x.Name == str);

                        if (u == null)
                            u = script.linked_users.Find(x => x.Name == str);

                        if (u != null)
                            this.SetPropertyValue((uint)this.count++, u, throwOnError: true);
                    }
            }
        }

        [JSProperty(Name = "length")]
        public int Length
        {
            get { return this.count; }
            set { }
        }

        public override string ToString()
        {
            return "[object IgnoreCollection]";
        }
    }
}
