﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;
using Jurassic.Library;
using ICallisto;

namespace callisto.Scripting.Objects
{
    class LinkedRoom : ObjectInstance
    {
        internal ILink parent;

        public LinkedRoom(ObjectInstance prototype, ILink link)
            : base(prototype)
        {
            this.PopulateFunctions();
            this.parent = link;
        }

        [JSProperty(Name = "externalIp")]
        public String ExternalIP
        {
            get { return this.parent.ExternalIP.ToString(); }
            set { }
        }

        [JSProperty(Name = "hashlink")]
        public String Hashlink
        {
            get { return this.parent.Hashlink; }
            set { }
        }

        [JSProperty(Name = "name")]
        public String Name
        {
            get { return this.parent.Name; }
            set { }
        }

        [JSProperty(Name = "port")]
        public int Port
        {
            get { return this.parent.Port; }
            set { }
        }

        [JSProperty(Name = "userCount")]
        public int UserCount
        {
            get { return this.parent.UserCount; }
            set { }
        }
    }
}
