﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;
using Jurassic.Library;

namespace callisto.Scripting.Objects
{
    class PM : ObjectInstance
    {
        public PMObject _PM { get; set; }

        public PM(ObjectInstance prototype, PMObject pm)
            : base(prototype)
        {
            this._PM = pm;
            this.PopulateFunctions();
            this.DefineProperty("contains", new PropertyDescriptor(this["contains"], PropertyAttributes.Sealed), throwOnError: true);
            this.DefineProperty("remove", new PropertyDescriptor(this["remove"], PropertyAttributes.Sealed), throwOnError: true);
            this.DefineProperty("replace", new PropertyDescriptor(this["replace"], PropertyAttributes.Sealed), throwOnError: true);
        }

        [JSFunction(Name = "contains")]
        public bool Contains(object a)
        {
            if (a != null)
                if (!(a is Undefined) && !(a is Null))
                    return this._PM.Contains(a.ToString());

            return false;
        }

        [JSFunction(Name = "remove")]
        public void Remove(object a)
        {
            if (a != null)
                if (!(a is Undefined) && !(a is Null))
                    this._PM.Remove(a.ToString());
        }

        [JSFunction(Name = "replace")]
        public void Replace(object a, object b)
        {
            if (a != null)
                if (!(a is Undefined) && !(a is Null))
                    if (b != null)
                        if (!(b is Undefined) && !(b is Null))
                            this._PM.Replace(a.ToString(), b.ToString());
        }

        public override string ToString()
        {
            return "[object PM]";
        }
    }
}
