﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;
using Jurassic.Library;

namespace callisto.Scripting.Statics
{
    class Base64 : ObjectInstance
    {
        public Base64(ScriptEngine engine)
            : base(engine)
        {
            this.PopulateFunctions();
            this.DefineProperty("encode", new PropertyDescriptor(this["encode"], PropertyAttributes.Sealed), throwOnError: true);
            this.DefineProperty("decode", new PropertyDescriptor(this["decode"], PropertyAttributes.Sealed), throwOnError: true);
        }

        [JSFunction(Name = "encode")]
        public static String Encode(object a)
        {
            if (a == null)
                return null;

            if (a is Null || a is Undefined)
                return null;

            return Convert.ToBase64String(Encoding.UTF8.GetBytes(a.ToString()));
        }

        [JSFunction(Name = "decode")]
        public static String Decode(object a)
        {
            if (a is String || a is ConcatenatedString)
            {
                String str = a.ToString();

                try
                {
                    return Encoding.UTF8.GetString(Convert.FromBase64String(str));
                }
                catch { }
            }

            return null;
        }
    }
}
