﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;
using Jurassic.Library;

namespace callisto.Scripting.Statics
{
    class Stats : ObjectInstance
    {
        public Stats(ScriptEngine engine)
            : base(engine)
        {
            this.PopulateFunctions();
        }

        [JSProperty(Name = "userCount")]
        public static double UserCount
        {
            get { return UserPool.UserCount; }
            set { }
        }

        [JSProperty(Name = "dataReceived")]
        public static double DataReceived
        {
            get { return CallistoPluginStats.data_received; }
            set { }
        }

        [JSProperty(Name = "dataSent")]
        public static double DataSent
        {
            get { return CallistoPluginStats.data_sent; }
            set { }
        }

        [JSProperty(Name = "floodCount")]
        public static double FloodCount
        {
            get { return CallistoPluginStats.flood_count; }
            set { }
        }

        [JSProperty(Name = "invalidLoginCount")]
        public static double InvalidLoginCount
        {
            get { return CallistoPluginStats.invalid_login_attempts; }
            set { }
        }

        [JSProperty(Name = "joinCount")]
        public static double JoinCount
        {
            get { return CallistoPluginStats.join_count; }
            set { }
        }

        [JSProperty(Name = "partCount")]
        public static double PartCount
        {
            get { return CallistoPluginStats.part_count; }
            set { }
        }

        [JSProperty(Name = "peakUserCount")]
        public static double PeakUserCount
        {
            get { return CallistoPluginStats.peak_user_count; }
            set { }
        }

        [JSProperty(Name = "rejectionCount")]
        public static double RejectionCount
        {
            get { return CallistoPluginStats.rejection_count; }
            set { }
        }

        [JSProperty(Name = "messageCount")]
        public static double MessageCount
        {
            get { return CallistoPluginStats.public_messages; }
            set { }
        }

        [JSProperty(Name = "pmCount")]
        public static double PMCount
        {
            get { return CallistoPluginStats.private_messages; }
            set { }
        }
    }
}
