﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;
using Jurassic.Library;

namespace callisto.Scripting.Statics
{
    class Users : ObjectInstance
    {
        public Users(ScriptEngine engine)
            : base(engine)
        {
            this.PopulateFunctions();
            this.DefineProperty("local", new PropertyDescriptor(this["local"], PropertyAttributes.Sealed), throwOnError: true);
            this.DefineProperty("linked", new PropertyDescriptor(this["linked"], PropertyAttributes.Sealed), throwOnError: true);
            this.DefineProperty("banned", new PropertyDescriptor(this["banned"], PropertyAttributes.Sealed), throwOnError: true);
        }

        [JSFunction(Name = "local", Flags = JSFunctionFlags.HasEngineParameter)]
        public static void Local(ScriptEngine eng, object f)
        {
            if (f is UserDefinedFunction)
            {
                CallistoScript script = ScriptManager.Scripts.Find(x => x.ScriptName == eng.ScriptName);

                if (script != null)
                {
                    UserDefinedFunction x = (UserDefinedFunction)f;

                    try
                    {
                        for (Scripting.Objects.User u = script.gbl.FirstUser(); u != null; u = u.NextUser())
                            x.Call(eng.Global, u);
                    }
                    catch { }
                }
            }
        }

        [JSFunction(Name = "linked", Flags = JSFunctionFlags.HasEngineParameter)]
        public static void Linked(ScriptEngine eng, object f)
        {
            if (f is UserDefinedFunction)
            {
                CallistoScript script = ScriptManager.Scripts.Find(x => x.ScriptName == eng.ScriptName);

                if (script != null)
                {
                    UserDefinedFunction x = (UserDefinedFunction)f;

                    try
                    {
                        for (Scripting.Objects.User u = script.gbl.FirstLinked(); u != null; u = u.NextUser())
                            x.Call(eng.Global, u);
                    }
                    catch { }
                }
            }
        }

        [JSFunction(Name = "banned", Flags = JSFunctionFlags.HasEngineParameter)]
        public static void Banned(ScriptEngine eng, object f)
        {
            if (f is UserDefinedFunction)
            {
                CallistoScript script = ScriptManager.Scripts.Find(x => x.ScriptName == eng.ScriptName);

                if (script != null)
                {
                    UserDefinedFunction x = (UserDefinedFunction)f;

                    try
                    {
                        for (Scripting.Objects.BannedUser u = script.gbl.FirstBanned(); u != null; u = u.NextUser())
                            x.Call(eng.Global, u);
                    }
                    catch { }
                }
            }
        }
    }
}
