﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jurassic;

namespace callisto.Scripting
{
    class TimerList
    {
        private static List<Objects.TimerInstance> list = new List<Objects.TimerInstance>();

        public static ulong NextIdent { get; set; }

        public static void UpdateTimers(long time)
        {
            if (list.Count > 0)
            {
                for (int i = (list.Count - 1); i > -1; i--)
                {
                    if (list[i].StartTime <= (time - list[i].Interval))
                    {
                        Objects.TimerInstance timer = list[i];
                        list.RemoveAt(i);
                        CallistoScript script = ScriptManager.Scripts.Find(x => x.ScriptName == timer.Engine.ScriptName);

                        if (script != null)
                        {
                            if (script.timer_idents.Contains(timer.IDENT))
                            {
                                try
                                {
                                    ScriptManager.PrintCounter = 0;

                                    if (timer.Callback != null)
                                        timer.Callback.Call(timer.Engine.Global);
                                }
                                catch (JavaScriptException e)
                                {
                                    ScriptManager.OnError(timer.ScriptName, e.Message, e.LineNumber);
                                }
                                catch { }
                            }
                        }
                    }
                }
            }
        }

        public static bool AddTimer(Objects.TimerInstance t)
        {
            if (!list.Contains(t))
            {
                t.StartTime = Helpers.UnixTimeMS;
                list.Add(t);
                return true;
            }

            return false;
        }

        public static bool RemoveTimer(Objects.TimerInstance t)
        {
            if (list.Contains(t))
            {
                list.Remove(t);
                return true;
            }

            return false;
        }

        public static void RemoveScriptTimers(String scriptName)
        {
            list.RemoveAll(x => x.ScriptName == scriptName);
        }
    }
}
