﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using ICallisto;

namespace callisto
{
    class PMObject : IPMObject
    {
        private String text;

        internal PMObject(String text)
        {
            this.text = text;
        }

        internal String GetText()
        {
            return this.text;
        }

        public bool Contains(String text)
        {
            return this.StripColors(this.text).ToUpper().Contains(text.ToUpper());
        }

        public void Remove(String text)
        {
            if (Regex.IsMatch(text, text, RegexOptions.IgnoreCase))
                text = Regex.Replace(this.text, text, String.Empty, RegexOptions.IgnoreCase);
        }

        public void Replace(String old_text, String new_text)
        {
            if (Regex.IsMatch(this.text, old_text, RegexOptions.IgnoreCase))
                text = Regex.Replace(this.text, old_text, new_text, RegexOptions.IgnoreCase);
        }

        private String StripColors(String str)
        {
            String input = str;

            if (Regex.IsMatch(input, @"\x03|\x05", RegexOptions.IgnoreCase))
                input = Regex.Replace(input, @"(\x03|\x05)[0-9]{2}", "");

            input = input.Replace("\x06", "");
            input = input.Replace("\x07", "");
            input = input.Replace("\x09", "");
            input = input.Replace("\x02", "");
            input = input.Replace("­", "");

            return input;
        }
    }
}
