﻿using System;
using System.Windows.Forms;
using ICallisto;

namespace callisto
{
    class PasswordItem : ListViewItem
    {
        private String username;
        private String password;
        private AdminLevel level;

        public String Username
        {
            get { return this.username; }
            set
            {
                this.username = value;
                this.SubItems[0].Text = this.username;
            }
        }

        public String Password
        {
            get { return this.password; }
            set
            {
                this.password = value;
                this.SubItems[1].Text = this.password;
            }
        }

        public AdminLevel Level
        {
            get { return this.level; }
            set
            {
                this.level = (AdminLevel)value;

                switch (value)
                {
                    case AdminLevel.Moderator:
                        this.SubItems[2].Text = "Mod";
                        break;

                    case AdminLevel.Administrator:
                        this.SubItems[2].Text = "Admin";
                        break;

                    case AdminLevel.Host:
                        this.SubItems[2].Text = "Host";
                        break;
                }
            }
        }

        public PasswordItem()
        {
            this.SubItems.AddRange(new ListViewSubItem[]
            {
                new ListViewSubItem(),
                new ListViewSubItem(),
                new ListViewSubItem()
            });
        }

        public PasswordItem(String Username, String Password, AdminLevel Level)
        {
            this.SubItems.AddRange(new ListViewSubItem[]
            {
                new ListViewSubItem(),
                new ListViewSubItem(),
                new ListViewSubItem()
            });

            this.Username = Username;
            this.Password = Password;
            this.Level = Level;
        }

        public override bool Equals(object obj)
        {
            return this.password == ((PasswordItem)obj).password;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}
