﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography;
using System.IO;
using ICallisto;

namespace callisto
{
    class PasswordManager
    {
        public static AdminLevel GetLevel(IUser userobj, String password)
        {
            PasswordItem p = Passwords.Items.Find(i => i.Password == password);

            if (p != null)
            {
                LoginHistory(userobj.Name + " [" + userobj.ExternalIP + "] logged in with password: " + password);
                return p.Level;
            }

            LoginHistory(userobj.Name + " [" + userobj.ExternalIP + "] logged in with invalid password: " + password);
            return AdminLevel.Regular;
        }

        public static bool IsSHA1Login(UserObject userobj, byte[] data)
        {
            if (userobj.level > AdminLevel.Regular || userobj.local_host)
                return false; // no point logging in twice

            if (data.Length != 20)
                return false; // SHA1 20 byte hash required!!

            foreach (PasswordItem p in Passwords.Items)
            {
                List<byte> buffer = new List<byte>();
                buffer.AddRange(BitConverter.GetBytes(userobj.cookie));
                buffer.AddRange(Settings.ServerIP.GetAddressBytes());
                buffer.AddRange(SHA1.Create().ComputeHash(Encoding.UTF8.GetBytes(p.Password)));
                byte[] result = SHA1.Create().ComputeHash(buffer.ToArray());

                if (result.SequenceEqual<byte>(data))
                {
                    LoginHistory(userobj.name + " [" + userobj.external_ip + "] logged in with password: " + p.Password);
                    userobj.Level = p.Level;
                    return true;
                }
            }

            return false;
        }

        private static void LoginHistory(String text)
        {
            StreamWriter s;

            try
            {
                if (!File.Exists(Settings.Path + "admin_login_attempts.txt"))
                    s = File.CreateText(Settings.Path + "admin_login_attempts.txt");
                else
                    s = File.AppendText(Settings.Path + "admin_login_attempts.txt");

                s.WriteLine(DateTime.Now.ToShortDateString() + " " + DateTime.Now.ToShortTimeString() + " " + text);
                s.Flush();
                s.Close();
            }
            catch { }
        }
    }
}
