﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using ICallisto;

namespace callisto
{
    class UserRecordManager
    {
        public static List<UserRecord> items = new List<UserRecord>();

        public static void AddRecord(IUser userobj)
        {
            items.RemoveAll(i => i.ExternalIP.Equals(userobj.ExternalIP) && i.Name == userobj.Name);
            items.Insert(0, new UserRecord(userobj));

            if (items.Count > 1500)
                items.RemoveRange(0, 500);
        }

        public static bool IsJoinFlooding(UserObject userobj)
        {
            uint time_now = Helpers.UnixTime;
            var linq = from i in items where i.ExternalIP.Equals(userobj.external_ip) && (i.JoinTime + 15) > time_now select i;
            return linq.Count<UserRecord>() > 0 && !userobj.local_host; // local hosts can join flood
        }

        public static bool IsJoinFlooding(WebUser userobj)
        {
            uint time_now = Helpers.UnixTime;
            var linq = from i in items where i.ExternalIP.Equals(userobj.ExternalIP) && (i.JoinTime + 15) > time_now select i;
            return linq.Count<UserRecord>() > 0; // local hosts can join flood
        }

        public static bool IsMaxClientsExcess(IUser userobj, int max_limit)
        {
            return UserPool.ClientCountByIP(userobj.ExternalIP) >= max_limit;
        }
    }

    class UserRecord// : IUser
    {
        private IPAddress external_ip;
        private String name;
        private uint time;

        public UserRecord(IUser userobj)
        {
            this.external_ip = userobj.ExternalIP;
            this.name = userobj.Name;
            this.time = Helpers.UnixTime;
        }

        public IPAddress ExternalIP { get { return this.external_ip; } }

        public String Name
        {
            get { return this.name; }
            set { }
        }

        public uint JoinTime { get { return this.time; } }
    }
}
