﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace callisto
{
    class UdpServerObject : IComparable
    {
        public IPAddress ip;
        public ushort port;
        public int ack_count;
        public int try_count;
        public int last_connect;
        public int last_sent_add_IPS;

        public UdpServerObject()
        {
            this.ack_count = 0;
            this.try_count = 0;
            this.last_connect = 0;
            this.last_sent_add_IPS = 0;
        }

        public UdpServerObject(IPAddress ip, ushort port)
        {
            this.ip = ip;
            this.port = port;
            this.ack_count = 0;
            this.try_count = 0;
            this.last_connect = 0;
            this.last_sent_add_IPS = 0;
        }

        public override bool Equals(object obj)
        {
            UdpServerObject c = (UdpServerObject)obj;
            return this.ip.Equals(c.ip);
        }

        public override int GetHashCode() { return base.GetHashCode(); }

        public int CompareTo(object obj)
        {
            UdpServerObject server = (UdpServerObject)obj;

            switch (UdpServerPool.SortMethod)
            {
                case UdpSortMethod.SortOldestContactedFirst:
                    return this.last_sent_add_IPS - server.last_sent_add_IPS;

                case UdpSortMethod.SortMostRecentFirst:
                    return server.last_connect - this.last_connect;

                case UdpSortMethod.SortMostAckedFirst:
                    return server.ack_count - this.ack_count;
            }

            return 0;
        }
    }
}
