﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography;
using System.Net;
using ICallisto;

namespace callisto
{
    class WebPackets
    {
        private static Random rnd = new Random();

        public static byte[] AresUserListItem(WebUser userobj)
        {
            return AresUserListItem(userobj, false);
        }

        public static byte[] AresUserListItem(WebUser userobj, bool include_version)
        {
            AresPacketWriter packet = new AresPacketWriter();
            packet.WriteInt16(userobj.FileCount);
            packet.WriteInt32(0);
            packet.WriteIP(userobj.ExternalIP);
            packet.WriteInt16(userobj.Port);
            packet.WriteIP(IPAddress.Parse("0.0.0.0"));
            packet.WriteInt16(0);
            packet.WriteByte(0);
            packet.WriteString(userobj.Name);
            packet.WriteIP(userobj.LocalIP);
            packet.WriteByte(userobj.Browsable ? (byte)1 : (byte)0);
            packet.WriteByte(0);

            if (include_version)
            {
                packet.WriteString(userobj.Version);
                packet.WriteBytes(new byte[16]);
                packet.WriteByte(userobj.Muzzled ? (byte)1 : (byte)00);
            }

            packet.WriteByte(userobj.Age);
            packet.WriteByte(userobj.Sex);
            packet.WriteByte(userobj.Country);
            packet.WriteString(userobj.Region);
            return packet.ToAresPacket(ProtoMessage.MSG_CHAT_SERVER_CHANNEL_USER_LIST);
        }

        public static byte[] AresUpdateUser(WebUser userobj)
        {
            AresPacketWriter packet = new AresPacketWriter();
            packet.WriteString(userobj.Name);
            packet.WriteInt16(userobj.FileCount);
            packet.WriteByte(userobj.Browsable ? (byte)1 : (byte)0);
            packet.WriteIP(IPAddress.Parse("0.0.0.0"));
            packet.WriteInt16(0);
            packet.WriteIP(userobj.ExternalIP);
            packet.WriteByte(0);
            packet.WriteByte(userobj.Age);
            packet.WriteByte(userobj.Sex);
            packet.WriteByte(userobj.Country);
            packet.WriteString(userobj.Region);
            return packet.ToAresPacket(ProtoMessage.MSG_CHAT_SERVER_UPDATE_USER_STATUS);
        }

        public static byte[] AresJoin(WebUser userobj)
        {
            return AresJoin(userobj, false);
        }

        public static byte[] AresJoin(WebUser userobj, bool include_version)
        {
            AresPacketWriter packet = new AresPacketWriter();
            packet.WriteInt16(userobj.FileCount);
            packet.WriteInt32(0);
            packet.WriteIP(userobj.ExternalIP);
            packet.WriteInt16(userobj.Port);
            packet.WriteIP(IPAddress.Parse("0.0.0.0"));
            packet.WriteInt16(0);
            packet.WriteByte(0);
            packet.WriteString(userobj.Name);
            packet.WriteIP(userobj.LocalIP);
            packet.WriteByte(userobj.Browsable ? (byte)1 : (byte)0);
            packet.WriteByte(0);

            if (include_version)
            {
                packet.WriteString(userobj.Version);
                packet.WriteBytes(new byte[16]);
                packet.WriteByte(userobj.Muzzled ? (byte)1 : (byte)00);
            }

            packet.WriteByte(userobj.Age);
            packet.WriteByte(userobj.Sex);
            packet.WriteByte(userobj.Country);
            packet.WriteString(userobj.Region);
            return packet.ToAresPacket(ProtoMessage.MSG_CHAT_SERVER_JOIN);
        }

        public static byte[] AresPart(WebUser userobj)
        {
            AresPacketWriter packet = new AresPacketWriter();
            packet.WriteString(userobj.Name);
            return packet.ToAresPacket(ProtoMessage.MSG_CHAT_SERVER_PART);
        }

        public static byte[] AresAvatar(WebUser userobj)
        {
            AresPacketWriter packet = new AresPacketWriter();
            packet.WriteString(userobj.Name);
            packet.WriteBytes(userobj.Avatar);
            return packet.ToAresPacket(ProtoMessage.MSG_CHAT_SERVER_AVATAR);
        }

        public static byte[] AresPersonalMessage(WebUser userobj)
        {
            AresPacketWriter packet = new AresPacketWriter();
            packet.WriteString(userobj.Name);
            packet.WriteString(userobj.PersonalMessage, false);
            return packet.ToAresPacket(ProtoMessage.MSG_CHAT_SERVER_PERSONAL_MESSAGE);
        }

        public static byte[] AckTo(WebUser userobj, String name)
        {
            return Html5TextPacket("ACK:" + name.Length + ":" + name, userobj.OldProto);
        }

        public static byte[] PublicTo(WebUser userobj, String name, String text)
        {
            String str = text;

            if (str.Length > 300)
                str = str.Substring(0, 300);

            return Html5TextPacket("PUBLIC:" + name.Length + "," + str.Length + ":" + name + str, userobj.OldProto);
        }

        public static byte[] EmoteTo(WebUser userobj, String name, String text)
        {
            String str = text;

            if (str.Length > 300)
                str = str.Substring(0, 300);

            return Html5TextPacket("EMOTE:" + name.Length + "," + str.Length + ":" + name + str, userobj.OldProto);
        }

        public static byte[] NoSuchTo(WebUser userobj, String text)
        {
            String str = text;

            if (str.Length > 300)
                str = str.Substring(0, 300);

            return Html5TextPacket("NOSUCH:" + str.Length + ":" + str, userobj.OldProto);
        }

        public static byte[] UpdateTo(WebUser userobj, String name, AdminLevel level)
        {
            return Html5TextPacket("UPDATE:" + name.Length + ",1:" + name + ((byte)level), userobj.OldProto);
        }

        public static byte[] UserlistItemTo(WebUser userobj, String name, AdminLevel level)
        {
            return Html5TextPacket("USERLIST:" + name.Length + ",1:" + name + ((byte)level), userobj.OldProto);
        }

        public static byte[] UserlistEndTo(WebUser userobj)
        {
            return Html5TextPacket("USERLIST_END:", userobj.OldProto);
        }

        public static byte[] JoinTo(WebUser userobj, String name, AdminLevel level)
        {
            return Html5TextPacket("JOIN:" + name.Length + ",1:" + name + ((byte)level), userobj.OldProto);
        }

        public static byte[] PartTo(WebUser userobj, String name)
        {
            return Html5TextPacket("PART:" + name.Length + ":" + name, userobj.OldProto);
        }

        public static byte[] FontTo(WebUser userobj, String name, int col1, int col2)
        {
            return Html5TextPacket("FONT:" + name.Length + "," + col1.ToString().Length + "," + col2.ToString().Length + ":" + name + col1.ToString() + col2.ToString(), userobj.OldProto);
        }

        public static byte[] UrlTo(WebUser userobj, String addr, String tag)
        {
            return Html5TextPacket("URL:" + addr.Length + "," + tag.Length + ":" + addr + tag, userobj.OldProto);
        }

        public static byte[] TopicTo(WebUser userobj, String text)
        {
            return Html5TextPacket("TOPIC:" + text.Length + ":" + text, userobj.OldProto);
        }

        public static byte[] TopicFirstTo(WebUser userobj, String text)
        {
            return Html5TextPacket("TOPIC_FIRST:" + text.Length + ":" + text, userobj.OldProto);
        }

        private static byte[] Html5TextPacket(String str, bool old_proto)
        {
            if (old_proto)
            {
                List<byte> list = new List<byte>();
                list.Add(0);
                list.AddRange(Encoding.UTF8.GetBytes(str));
                list.Add(255);
                return list.ToArray();
            }
            else
            {
                byte[] text = Encoding.UTF8.GetBytes(str);
                List<byte> list = new List<byte>();
                list.Add(129);

                if (text.Length <= 125)
                    list.Add((byte)text.Length);
                else if (text.Length < 65535)
                {
                    list.Add(126);
                    byte[] len = BitConverter.GetBytes((ushort)text.Length);
                    Array.Reverse(len);
                    list.AddRange(len);
                }
                else
                {
                    list.Add(127);
                    byte[] len = BitConverter.GetBytes((ulong)text.Length);
                    Array.Reverse(len);
                    list.AddRange(len);
                }

          /*      list[1] = (byte)(list[1] | 128);

                byte[] key = BitConverter.GetBytes(rnd.Next(int.MaxValue));

                list.AddRange(key);

                for (int i = 0; i < text.Length; i++)
                    list.Add((byte)(text[i] ^ key[i % 4]));*/

                list.AddRange(text);

                return list.ToArray();
            }
        }

        public static byte[] Html5HandshakeReplyPacket(Html5RequestEventArgs e)
        {
            if (e.OldProto)
            {
                String str = String.Empty;
                str += "HTTP/1.1 101 WebSocket Protocol Handshake\r\n";
                str += "Upgrade: WebSocket\r\n";
                str += "Connection: Upgrade\r\n";
                str += "Sec-WebSocket-Origin: " + e.Origin + "\r\n";
                str += "Sec-WebSocket-Location: ws://" + e.Host + "/\r\n";
                str += "\r\n";

                List<byte> list = new List<byte>();
                list.AddRange(Encoding.Default.GetBytes(str));
                list.AddRange(BuildOldKeyResponse(e.Key1, e.Key2, e.KeyData));

                return list.ToArray();
            }
            else
            {
                String str = String.Empty;
                str += "HTTP/1.1 101 Switching Protocols\r\n";
                str += "Upgrade: websocket\r\n";
                str += "Connection: Upgrade\r\n";
                
                String sha1 = e.Key;
                sha1 += "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";
                byte[] buffer = Encoding.Default.GetBytes(sha1);
                buffer = SHA1.Create().ComputeHash(buffer);
                sha1 = Convert.ToBase64String(buffer);

                str += "Sec-WebSocket-Accept: " + sha1 + "\r\n";
                str += "Access-Control-Allow-Origin: " + e.Origin + "\r\n";
                str += "Access-Control-Allow-Credentials: true\r\n";
                str += "Access-Control-Allow-Headers: content-type\r\n";
                str += "\r\n";

                return Encoding.Default.GetBytes(str);
            }
        }

        private static byte[] BuildOldKeyResponse(String key1, String key2, byte[] cookie)
        {
            List<byte> list = new List<byte>();
            long l;
            int i;
            byte[] buf;

            l = long.Parse(new String(key1.Where(x => Char.IsNumber(x)).ToArray()));
            i = (int)(l / key1.Count(x => x == ' '));
            buf = BitConverter.GetBytes(i);
            Array.Reverse(buf);
            list.AddRange(buf);

            l = long.Parse(new String(key2.Where(x => Char.IsNumber(x)).ToArray()));
            i = (int)(l / key2.Count(x => x == ' '));
            buf = BitConverter.GetBytes(i);
            Array.Reverse(buf);
            list.AddRange(buf);

            list.AddRange(cookie);

            return MD5.Create().ComputeHash(list.ToArray());
        }
    }
}
